//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Space Moves
//  Copyright (C) 2015 Toni Ramírez (@AmstradGamer)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include "tilemap.h"

const u8 G_frame_1[8] = {
    0x00, 0x30,
    0x10, 0xF0,
    0x70, 0xF0,
    0x70, 0x30};


const u8 G_frame_2[8] = {
    0x30, 0x00,
    0xF0, 0x20,
    0xF0, 0xB0,
    0x30, 0xB0};


const u8 G_frame_3[8] = {
    0x70, 0x30,
    0x70, 0xF0,
    0x10, 0xF0,
    0x00, 0x30};


const u8 G_frame_4[8] = {
    0x30, 0xB0,
    0xF0, 0xB0,
    0xF0, 0x20,
    0x30, 0x00};


const u8 G_frame_5[8] = {
    0x30, 0x30,
    0xF0, 0xF0,
    0xF0, 0xF0,
    0x30, 0x30};


const u8 G_frame_6[8] = {
    0x70, 0x00,
    0x70, 0x00,
    0x70, 0x00,
    0x70, 0x00};


const u8 G_frame_7[8] = {
    0x00, 0xB0,
    0x00, 0xB0,
    0x00, 0xB0,
    0x00, 0xB0};

const u8 G_floor_0[32] = {
    0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00};

const u8 G_floor_1[32] = {
    0x05, 0x05, 0x87, 0x41,
    0x0A, 0xC3, 0x00, 0x0F,
    0x87, 0xC3, 0x4B, 0xC3,
    0x4E, 0x87, 0x87, 0x8D,
    0xC3, 0x0F, 0xC3, 0x0F,
    0x3C, 0x02, 0x14, 0x89,
    0x29, 0x89, 0x14, 0x02,
    0x29, 0xCC, 0x14, 0x29};


const u8 G_floor_2[32] = {
    0x29, 0xCC, 0x14, 0x29,
    0x46, 0xCC, 0x02, 0x01,
    0x03, 0xCC, 0x02, 0x46,
    0x03, 0xCC, 0x14, 0x29,
    0x03, 0x89, 0x00, 0x29,
    0x46, 0x16, 0x03, 0x14,
    0x29, 0x28, 0x46, 0x14,
    0x3C, 0x14, 0xCC, 0x88};


const u8 G_floor_3[32] = {
    0x05, 0x05, 0x87, 0x41,
    0x0A, 0xC3, 0x00, 0x0F,
    0x87, 0xC3, 0x4B, 0xC3,
    0x4E, 0x87, 0x87, 0x8D,
    0xC3, 0x0F, 0xC3, 0x0F,
    0x3C, 0x02, 0x14, 0x89,
    0x29, 0x89, 0x14, 0x02,
    0x29, 0xCC, 0x14, 0x28};


const u8 G_floor_4[32] = {
    0x29, 0xCC, 0x14, 0x28,
    0x46, 0xCC, 0x02, 0x00,
    0x03, 0xCC, 0x02, 0x00,
    0x03, 0xCC, 0x00, 0x00,
    0x03, 0x89, 0x00, 0x00,
    0x46, 0x16, 0x00, 0x00,
    0x29, 0x28, 0x00, 0x00,
    0x3C, 0x00, 0x00, 0x00};

const u8 G_floor_5[32] = {
    0x05, 0x05, 0x87, 0x41,
    0x0A, 0xC3, 0x00, 0x0F,
    0x87, 0xC3, 0x4B, 0xC3,
    0x4E, 0x87, 0x87, 0x8D,
    0xC3, 0x0F, 0xC3, 0x0F,
    0x3C, 0x02, 0x14, 0x89,
    0x03, 0x89, 0x14, 0x02,
    0x01, 0xCC, 0x14, 0x29};


const u8 G_floor_6[32] = {
    0x01, 0xCC, 0x14, 0x29,
    0x00, 0x46, 0x02, 0x01,
    0x00, 0x46, 0x02, 0x46,
    0x00, 0x01, 0x9C, 0x29,
    0x00, 0x00, 0x03, 0x29,
    0x00, 0x00, 0x01, 0x9C,
    0x00, 0x00, 0x00, 0x16,
    0x00, 0x00, 0x00, 0x14};

u8* const g_floorTileset[FLOOR_NUMTILES] = { G_floor_0, G_floor_1, G_floor_2, G_floor_3, G_floor_4, G_floor_5, G_floor_6};

const u8 g_floorTilemap[FLOOR_WIDTH * FLOOR_HEIGHT] = {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 1, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1,
    1, 1, 9, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 9, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 1, 1, 1,
    1, 1, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1,
    1, 1, 9, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 3, 0, 0, 0, 5, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9,
    1, 1, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 1, 9, 1, 1,
    1, 1, 9, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1,
    1, 1, 1, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 9, 1, 1,
    1, 1, 9, 3, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1,
    1, 1, 9, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 3, 0, 0, 0, 5, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1,
    1, 1, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 1, 1, 1, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0,
    5, 1, 1, 3, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1,
    1, 1, 9, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 3, 0, 0, 0, 5, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1,
    1, 9, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 9, 1, 1,
    9, 1, 1, 1, 1, 9, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1,
    1, 9, 1, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 1, 9, 1,
    1, 1, 1, 3, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 3, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 1, 1, 9, 1,
    1, 9, 1, 3, 0, 0, 0, 5, 1, 3, 0, 0, 0, 5, 1, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1, 3, 0, 0, 0, 5, 1, 1, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 1,
    1, 9, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 5, 1, 1, 1, 3, 0, 0, 0, 5, 1, 1, 3, 0, 0, 0, 0, 5, 1, 3, 0, 0, 0, 0, 5, 1, 1, 1, 1, 1, 9,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
};
    